﻿//---------------------------------------------------------------------
// <copyright file="CoreVocabularyConstants.cs" company="Microsoft">
//      Copyright (C) Microsoft Corporation. All rights reserved. See License.txt in the project root for license information.
// </copyright>
//---------------------------------------------------------------------

namespace Microsoft.OData.Edm.Vocabularies.V1
{
    /// <summary>
    /// Constant values for Core Vocabulary
    /// </summary>
    public static class CoreVocabularyConstants
    {
        /// <summary>Org.OData.Core.V1</summary>
        public const string CoreNamespace = "Org.OData.Core.V1";

        /// <summary>Org.OData.Core.V1.Description </summary>
        public const string Description = "Org.OData.Core.V1.Description";

        /// <summary>Org.OData.Core.V1.LongDescription </summary>
        public const string LongDescription = "Org.OData.Core.V1.LongDescription";

        /// <summary>Org.OData.Core.V1.IsLanguageDependent </summary>
        public const string IsLanguageDependent = "Org.OData.Core.V1.IsLanguageDependent";

        /// <summary>Org.OData.Core.V1.RequiresType </summary>
        public const string RequiresType = "Org.OData.Core.V1.RequiresType";

        /// <summary>Org.OData.Core.V1.ResourcePath</summary>
        public const string ResourcePath = "Org.OData.Core.V1.ResourcePath";

        /// <summary>Org.OData.Core.V1.DereferenceableIDs</summary>
        public const string DereferenceableIDs = "Org.OData.Core.V1.DereferenceableIDs";

        /// <summary>Org.OData.Core.V1.ConventionalIDs</summary>
        public const string ConventionalIDs = "Org.OData.Core.V1.ConventionalIDs";

        /// <summary>Org.OData.Core.V1.Permissions</summary>
        public const string Permissions = "Org.OData.Core.V1.Permissions";

        /// <summary>Org.OData.Core.V1.Immutable</summary>
        public const string Immutable = "Org.OData.Core.V1.Immutable";

        /// <summary>Org.OData.Core.V1.Computed</summary>
        public const string Computed = "Org.OData.Core.V1.Computed";

        /// <summary>Org.OData.Core.V1.IsURL</summary>
        public const string IsURL = "Org.OData.Core.V1.IsURL";

        /// <summary>Org.OData.Core.V1.AcceptableMediaTypes</summary>
        public const string AcceptableMediaTypes = "Org.OData.Core.V1.AcceptableMediaTypes";

        /// <summary>Org.OData.Core.V1.MediaType</summary>
        public const string MediaType = "Org.OData.Core.V1.MediaType";

        /// <summary>Org.OData.Core.V1.IsMediaType</summary>
        public const string IsMediaType = "Org.OData.Core.V1.IsMediaType";

        /// <summary>Org.OData.Core.V1.OptimisticConcurrency </summary>
        public const string OptimisticConcurrency = "Org.OData.Core.V1.OptimisticConcurrency";

        /// <summary>Org.OData.Core.V1.OptionalParameter</summary>
        public const string OptionalParameter = "Org.OData.Core.V1.OptionalParameter";

        /// <summary>Org.OData.Core.V1.Revisions</summary>
        public const string Revisions = "Org.OData.Core.V1.Revisions";

        /// <summary>Org.OData.Core.V1.AlternateKeys</summary>
        public const string AlternateKeys = "Org.OData.Core.V1.AlternateKeys";

        // <summary>Org.OData.Core.V1.AlternateKey</summary>
        public const string AlternateKey = "Org.OData.Core.V1.AlternateKey";

        // <summary>Org.OData.Core.V1.PropertyRef</summary>
        public const string PropertyRef = "Org.OData.Core.V1.PropertyRef";

        /// <summary>Org.OData.Core.V1.xml file suffix</summary>
        internal const string VocabularyUrlSuffix = "/Org.OData.Core.V1.xml";
    }
}
